' XDELETE.BAS.
'
' This example demonstrates the use of the BTDELETE B-Tree API.
'

#COMPILE EXE

#INCLUDE "DVBTREE.INC"

DEFLNG A-Z

FUNCTION WinMain& (BYVAL CurInst&, _
                   BYVAL PrvInst&, _
                   BYVAL CmdL AS ASCIIZ PTR, _
                   BYVAL CmdShow&) EXPORT

DATA "000000000004","ONIONS YELLOW                   "
DATA "000000000059","CORN WHITE                      "
DATA "000000000060","CORN YELLOW                     "
DATA "000000000067","STRAWBERRY P                    "
DATA "001300000133","HEINZ KETCHU                    "
DATA "001600010610","G MEDAL PL F                    "
DATA "001600011610","G MEDAL SR F                    "
DATA "001890002665","S-L POLISH S                    "
DATA "001890002828","SUNNLD HOT D                    "
DATA "001890003887","S-L SLICED B                    "
DATA "003040000061","SPARKLE TOWE                    "
DATA "003370047531","MERICO BUTTE                    "
DATA "003700035521","TIDE WASHING                    "
DATA "003700035522","TIDE FREE                       "
DATA "003700035526","TIDE MTN SPR                    "
DATA "003700035527","TIDE/BLEACH                     "
DATA "003700035528","TIDE MTN/BL                     "
DATA "004145810534","EDW KEYLIME                     "
DATA "004145810535","APPLE CHEESE                    "
DATA "004145810550","EDW PECAN CH                    "
DATA "004145810568","EDWARDS TURTLE PIE              "
DATA "004150000710","FRENCH MUSTA                    "
DATA "004830004255","PATIO BF&BN                     "
DATA "004830004256","PATIO BF+BN                     "
DATA "004830004257","PATIO BF&BN                     "
DATA "005020000322","SUNNY DEL128                    "
DATA "005020000880","SUNNY DELIGH                    "
DATA "005250005805","BAMA MAYONNA                    "
DATA "005300000051","BORDENS CHK                     "
DATA "005300000052","BORDEN CHK                      "
DATA "005300000053","BORDENS CHK                     "
DATA "005300000068","BORDEN CHK                      "
DATA "005300004881","BORDEN SHREDDED                 "
DATA "005300005281","BORDEN SHREDDED                 "
DATA "005300005381","BORDEN SHREDDED                 "
DATA "005300006881","BORDEN SHREDDED                 "
DATA "005300007161","BORDEN SHREDDED                 "
DATA "007056092006","PICTSW CREAM                    "
DATA "007056092008","PICSW WHITE                     "
DATA "007099060333","SUNNYLAND SP                    "
DATA "007170028081","CROWLEY SC                      "
DATA "007360000290","EMPRESS FRT COCKTAIL            "
DATA "007520000172","RODBRY HMBRG                    "
DATA "007524320104","MAYFIELD BRO                    "
DATA "007524320106","MAYFIELD BLK                    "
DATA "007524320111","MAYFIELD BUT                    "
DATA "007524320120","MAYFIELD TUR                    "
DATA "007524320121","MAYFIELD CHO                    "
DATA "007524320124","MAYFIELD MOO                    "
DATA "007524320138","MAYFIELD BAN                    "
DATA "007524320139","MAYFIELD ROC                    "
DATA "007524320148","MAYFIELD VAN                    "
DATA "007524320170","MAYFIELD BAN                    "
DATA "007524320175","MAYFIELD VAN                    "
DATA "007524320176","MAYFIELD CHO                    "
DATA "007710000001","EL CHARRITO                     "
DATA "007710000002","EL CHARRITO                     "
DATA "007710000010","EL CHAR SALT                    "
DATA "075188482552","BAKERITE SHO                    "
DATA "002840000501","LAYS CRACKER                    "
DATA "002840001024","WAVY LAYS                       "
DATA "002840002090","WAVY LAYS                       "
DATA "002840002091","FL WAVY LAYS                    "
DATA "002840002106","LAY''S CLASC                    "
DATA "002840002107","KC MASTERPC                     "
DATA "002840002108","LAY'S SC & O                    "
DATA "002840002109","LAYS SALT AN                    "
DATA "002410012270","CHEEZ-IT                        "
DATA "004900000249","COCA COLA                       "
DATA "004900001134","DIET COKE                       "
DATA "004900001137","CF DIET COKE                    "
DATA "004900001139","SPRITE                          "
DATA "004900001140","DIET SPRITE                     "
DATA "004900001259","COKE-COLA                       "
DATA "007189962416","BB ICE CREAM                    "
DATA "007189962417","BB COOKIES N                    "
DATA "007525300005","DEANS MLD SA                    "
DATA "007525300006","DEANS HOT SA                    "
DATA "007525300009","DEANS CHILD                     "


    BtreeName$ = "BTDELETE.NDX"
    Klen2& = 44

    REDIM KeyName$(79), KeyName2$(79)
    RECCNTR& = 1

    FOR X& = 1 TO 158 STEP 2
        TMP$=READ$(X&)
        KEYNAME$(RECCNTR&)=TMP$
        TMP$=READ$(X&+1)
        KEYNAME2$(RECCNTR&)=TMP$ + KEYNAME$(RECCNTR&)
        INCR RECCNTR&
    NEXT

    CALL dvKillFile((BtreeName$))
  
    ErrCode& = dvBtOpen&((BtreeName$), Klen2&, hBtFile&, BtErr&)
    Ok& = -1
    FOR K& = 1 TO 79
        Record& = K&: InsertKey$ = KeyName2$(K&)
        ErrCode& = dvBtInsert& (hBtFile&, (InsertKey$), Record&, BtErr&)
        IF BtErr& THEN
           Msg$ = "Error" + STR$(BtErr&) + " inserting key #" + STR$(K&)
           MSGBOX Msg$,,"XDELETE"
           Ok& = 0
        END IF
    NEXT
    CALL dvBtClose(hBtFile&)
  
    IF Ok& THEN
       MSGBOX LTRIM$(STR$(K& - 1)) + " keys were succesfully inserted in BTDELETE.NDX",,"XDELETE"
    END IF
  
  ' WARNING because this example just use the index,
    Ok& = -1
    ErrCode& = dvBtOpen&((BtreeName$), Klen2&, hBtFile&, BtErr&)
    FOR K& = 1 TO 79
        Record& = K&: InsertKey$ = KeyName2$(K&)
        ErrCode& = dvBtDelete (hBtFile&, (InsertKey$), Record&, BtErr&)
        IF BtErr& THEN
           Msg$ = "Error:" + STR$(BtErr&) + " DELETING key #" + STR$(K&)
           MSGBOX Msg$,,"XDELETE"
           Ok& = 0
        ELSE
        END IF
    NEXT
    CALL dvBtClose(hBtFile&)

    IF Ok& THEN
       MSGBOX "79 keys were succesfully deleted in BTDELETE.NDX",,"XDELETE"
    END IF

END FUNCTION



